/*
** Trackerboy - Gameboy / Gameboy Color music tracker
** Copyright (C) 2019-2021 stoneface86
**
** Permission is hereby granted, free of charge, to any person obtaining a copy
** of this software and associated documentation files (the "Software"), to deal
** in the Software without restriction, including without limitation the rights
** to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
** copies of the Software, and to permit persons to whom the Software is
** furnished to do so, subject to the following conditions:
**
** The above copyright notice and this permission notice shall be included in all
** copies or substantial portions of the Software.
**
** THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
** IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
** FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
** AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
** LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
** OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
** SOFTWARE.
**
*/

#pragma once

#include "trackerboy/engine/Operation.hpp"

#include <cstdint>


namespace trackerboy {

//
// Global effect state for the MusicRuntime
//
struct GlobalState {


    constexpr GlobalState() :
        patternCommand(Operation::PatternCommand::none),
        patternCommandParam(0),
        speed(0),
        sweep(0),
        volume(0),
        halt(false)
    {
    }


    // pattern effects / global effects
    Operation::PatternCommand patternCommand;
    uint8_t patternCommandParam;
    uint8_t speed; // change speed if nonzero
    uint8_t sweep; // change sweep if >= 0x80
    uint8_t volume; // change global volume if >= 0x80
    bool halt;



};

}
