
#include "forms/MainWindow/aboutstr.hpp"

#include <QString>
#include <QtGlobal>

#include "miniaudio.h"
#include "RtMidi.h"


static QString const ABOUT_STR_BEGIN =
QStringLiteral(R"html(
<html><head/><body>
<h1>Trackerboy v0.6.5</h1>
<h3>Game Boy / Game Boy Color music tracker</h3>
<h3>Copyright (C) 2019-2022 stoneface86</h3>
<p>
<a href="https://www.trackerboy.org">www.trackerboy.org</a>
<br>
Repo - <a href="https://github.com/stoneface86/trackerboy">https://github.com/stoneface86/trackerboy</a>
<br>
Commit: GITDIR-NOTFOUND
</p>
<p>This software is licensed under the MIT License.</p>
<hr>
<h3>Libraries</h3>
)html");

static QString const ABOUT_STR_END = QStringLiteral("</ul></body></html>");

static void addLibraryItem(QString &str, QString const& item) {
    str.append(QStringLiteral("<li>"));
    str.append(item);
    str.append(QStringLiteral("</li>"));
}

QString getAboutString() {
    QString result(ABOUT_STR_BEGIN);
    addLibraryItem(result,
        QStringLiteral("Qt %1").arg(qVersion())
    );
    addLibraryItem(result,
        QStringLiteral("Miniaudio %1 (C) David Reid").arg(ma_version_string())
    );
    addLibraryItem(result,
        QStringLiteral("RtMidi %1 (C) Gary P. Scavone").arg(
            QString::fromStdString(RtMidi::getVersion())
        )
    );
    result.append(ABOUT_STR_END);
    return result;
}
